#include <fork.h>
#include <syscall.h>
#include <io.h>
#include <assert.h>
#include <math.h>

sh int outerloop = 8, innerloop = 8, subgroups = 2;
sh int outerloopi;

void
main(int ac, char *av[])
{
	pr int j;

	if (!__PROC_NR__) {
		if (ac > 1)
			outerloop = atoi(av[1]);
		if (ac > 2)
			innerloop = atoi(av[2]);
		if (ac > 3)
			subgroups = atoi(av[3]);
	}

	barrier;

	if (outerloop <= 0 || innerloop <= 0 || subgroups <= 0)
		exit(1);

	asm ("\n\t/*pre start*/");
	start {
		asm ("\t/*post start*/\n");

		asm ("\t/*pre outer-for*/");
		for (outerloopi = 0; outerloopi < outerloop; outerloopi++) {
			asm ("\t/*post outer-for*/\n");

			asm ("\t/*pre fork*/");
			fork (subgroups;
			      @ = __PROC_NR__ % subgroups;
			      $ = __PROC_NR__ / subgroups) {
				asm ("\t/*post fork*/\n");

				j = innerloop;
				farm while (j--);

				asm ("\n\t/*pre fork-end*/");
			}
			asm ("\t/*post fork-end*/\n");

			/*exgrp*/

			asm ("\n\t/*pre outer-for-end*/");
		}
		asm ("\t/*post outer-for-end*/\n");

		asm ("\n\t/*pre start-end*/");
	}
	asm ("\t/*post start-end*/\n");

	exit(0);
}

