#include <fork.h>
#include <syscall.h>
#include <io.h>
#include <assert.h>
#include <math.h>

sh int c = 8;

void
main(int ac, char *av[])
{

    if (!__PROC_NR__) {
        if (ac > 1) {
            c = atoi(av[1]);
            c = (c + c - 1) / __STARTED_PROCS__;
        }
    }

    asm("/*bw: sync */\n");
    barrier;

    if (c <= 0)
        exit(1);

    asm("/*bw: async -> sync */\n");
    asm("nop\nshint\t 8\n");
    start {
        pr int i;

        for (i = 0; i < c; i++) {
            asm("/*bw: sync -> async */\n");
            asm("nop\nshint\t 9\n");
            farm {
                asm("/*bw: loop */\n");
                asm("\
getlo\t 1024,r19\n\
getlo\t 1,r20\n\
synt_loop:\n\
sub\t r20,r19,r19\t # r19 <- r19 - r20\n\
bne\t synt_loop\n");

                asm("/*bw: end */\n");
            }
            asm("/*bw: sync */\n");
            asm("nop\nshint\t 8\n");
        }
    }
    asm("nop\nshint\t 9\n");

    exit(0);
}

